Imports System.ComponentModel
Imports Syncfusion.Windows.Forms.Chart
Imports PLCDemo.Forms

Namespace Chart

    Public Class ArraylistModel
        Implements IChartSeriesModel

#Region " declarations "
        Private frmParent As frmMain

        Private xData As ArrayList
        Private yData As ArrayList

        Private m_TopCountVal As Integer

        Public Event Changed As ListChangedEventHandler Implements IChartSeriesModel.Changed
#End Region

#Region " properties "
        Public ReadOnly Property Count() As Integer Implements IChartSeriesModel.Count
            Get
                Return Me.xData.Count
            End Get
        End Property

        Public Property TopCount() As Integer
            Get
                Return Me.m_TopCountVal
            End Get
            Set(ByVal Value As Integer)
                Me.m_TopCountVal = Value
            End Set
        End Property
#End Region

#Region " constructor / destructor "
        Public Sub New(ByVal parent As frmMain)
            Me.frmParent = parent
            Me.xData = New ArrayList
            Me.yData = New ArrayList
        End Sub
#End Region

#Region " methods "
        Public Function GetY(ByVal index As Integer) As Double() Implements IChartSeriesModel.GetY
            Return Me.yData(index)
        End Function

        Public Function GetX(ByVal index As Integer) As Double Implements IChartSeriesModel.GetX
            Return Me.xData(index)
        End Function

        Public Sub InvokeRaiseListChanged()
            Me.frmParent.Invoke(New MethodInvoker(AddressOf Me.RaiseListChanged))
        End Sub

        Private Sub RaiseListChanged()
            'Me.frmParent.ccPLCData.BeginUpdate()
            'Me.frmParent.ccPLCData.SuspendLayout()
            RaiseEvent Changed(Me, New ListChangedEventArgs(ListChangedType.Reset, -1))
            'Me.frmParent.ccPLCData.ResumeLayout(False)
            'Me.frmParent.ccPLCData.EndUpdate()
        End Sub

        Public Sub AddXY(ByVal xValue As Double, ByVal yValue As Double())
            Me.xData.Add(xValue)
            Me.yData.Add(yValue)
            Me.InvokeRaiseListChanged()
        End Sub

        Public Sub AddRange(ByVal xValues As ArrayList, ByVal yValues As ArrayList)
            Me.xData.AddRange(xValues)
            Me.yData.AddRange(yValues)
            Me.InvokeRaiseListChanged()
        End Sub

        Public Sub Clear()
            Me.xData.Clear()
            Me.yData.Clear()
            Me.InvokeRaiseListChanged()
        End Sub

        Public Function GetEmpty(ByVal index As Integer) As Boolean Implements IChartSeriesModel.GetEmpty
            Return False
        End Function
#End Region

    End Class

End Namespace